// Description: 
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.FreeOTFE.org/
//
// -----------------------------------------------------------------------------
//

#ifndef _FreeOTFEPlatform_H
#define _FreeOTFEPlatform_H   1

#ifdef WINCE
#define FREEOTFE_MEMALLOC(x)              malloc(x)
#define FREEOTFE_MEMCALLOC(x, y)          calloc(x, y)
#define FREEOTFE_FREE(x)                  free(x)
#define FREEOTFE_MEMZERO(x, size)         memset(x, 0, size)
#define FREEOTFE_MEMCPY(dest, src, size)  memcpy(dest, src, size)
#else
// Visual Studio has ExAllocatePool(...) marked as deprecated
//#define FREEOTFE_MEMALLOC(x)              ExAllocatePool(NonPagedPool, x)
#define FREEOTFE_MEMALLOC(x)              ExAllocatePoolWithTag(NonPagedPool, x, 'FOTF')
#define FREEOTFE_MEMCALLOC(x, y)          FREEOTFE_MEMALLOC((x * y))
#define FREEOTFE_FREE(x)                  ExFreePool(x)
#define FREEOTFE_MEMZERO(x, size)         RtlZeroMemory(x, size)
#define FREEOTFE_MEMCPY(dest, src, size)  RtlCopyMemory(dest, src, size)
#endif

#define FREEOTFEBYTE  unsigned char
#define FREEOTFEBOOL  BOOLEAN


#endif

